import { TryCatchFinallyHook, DecoratorArgsOf, ITryCatchFinallyHooksCollection, IHooksFunc } from "./TryCatchFinallyHook";
import { FunctionContext, WrappableFunction } from "./tryCatchFinally";
/** @inheritDoc {@link ITryCatchFinallyHooksCollection} */
export declare class Hooks<FullHookContext extends FunctionContext = FunctionContext> implements ITryCatchFinallyHooksCollection<FullHookContext> {
    private hooks;
    add<TNewContext extends {} = {}, TryReturnContext = {}>(hook: TryCatchFinallyHook<FullHookContext & TNewContext, TryReturnContext>): Hooks<FullHookContext & TNewContext & TryReturnContext>;
    wrap<TFunc extends WrappableFunction>(args: DecoratorArgsOf<FullHookContext> | undefined, func: TFunc): TFunc;
    wrap<TFunc extends WrappableFunction>(func: TFunc): TFunc;
    /**
     * @param args
     * @returns
     */
    decor(args?: DecoratorArgsOf<FullHookContext>): MethodDecorator & (<TFunc extends WrappableFunction>(func: TFunc) => TFunc);
    scope<TResult>(args: DecoratorArgsOf<FullHookContext>, scope: () => TResult): TResult;
    protected beforeHooksTry(ctx: FullHookContext): {
        onCatch?(): void;
        onFinally?(): void;
    };
    protected afterHooksTry?(ctx: FullHookContext): {
        onCatch?(): void;
        onFinally?(): void;
    };
    private _currentContext;
    /**
     * Only safe to use in sync functions or in async functions before any awaited code.
     * Otherwise, the context may be changed by another async function - in that case use callStack hook instead
     */
    get context(): (FullHookContext & FunctionContext) | undefined;
    create(): IHooksFunc<this>;
}
//# sourceMappingURL=Hooks.d.ts.map