import { ITryCatchFinallyHook } from "./TryCatchFinallyHook";
export type CallStackContext = {
    args: {
        name?: string;
        isVisibleInCallStack?: boolean;
    };
    name: string;
    id: string;
    /**
     * Returns current tracked callstack. Filters Error.captureStackTrace by tracked functions.
     * If you don't see actions in your callstack, increase Error.stackTraceLimit
     */
    getCallStack(): CallStackContext[];
};
export declare const callStack: ITryCatchFinallyHook<CallStackContext>;
/**
 * Returns current tracked callstack. Filters Error.captureStackTrace by tracked functions.
 * If you don't see actions in your callstack, increase Error.stackTraceLimit
 */
export declare function getCurrentCallstack(): CallStackContext[];
//# sourceMappingURL=callStack.d.ts.map